Index: /trunk/BNC/src/PPP_free/pppClient.cpp
===================================================================
--- /trunk/BNC/src/PPP_free/pppClient.cpp	(revision 6084)
+++ /trunk/BNC/src/PPP_free/pppClient.cpp	(revision 6085)
@@ -27,5 +27,5 @@
  * -------------------------------------------------------------------------
  *
- * Class:      bncPPPclient
+ * Class:      t_pppClient
  *
  * Purpose:    Precise Point Positioning
@@ -56,9 +56,9 @@
 // Global variable holding thread-specific pointers
 //////////////////////////////////////////////////////////////////////////////
-bncPPPclient* PPP_CLIENT = 0;
+t_pppClient* PPP_CLIENT = 0;
 
 // Static function returning thread-specific pointer
 //////////////////////////////////////////////////////////////////////////////
-bncPPPclient* t_pppClient::instance() {
+t_pppClient* t_pppClient::instance() {
   return PPP_CLIENT;
 }
@@ -66,5 +66,5 @@
 // Constructor
 ////////////////////////////////////////////////////////////////////////////
-bncPPPclient::bncPPPclient(const t_pppOptions* opt) : bncEphUser(false) {
+t_pppClient::t_pppClient(const t_pppOptions* opt) : bncEphUser(false) {
 
   _opt       = new t_pppOptions(*opt);
@@ -77,5 +77,5 @@
 // Destructor
 ////////////////////////////////////////////////////////////////////////////
-bncPPPclient::~bncPPPclient() {
+t_pppClient::~t_pppClient() {
   _epoData->clear();
 
@@ -99,5 +99,5 @@
 //
 ////////////////////////////////////////////////////////////////////////////
-void bncPPPclient::processEpoch(const vector<t_satObs*>& satObs, t_output* output) {
+void t_pppClient::processEpoch(const vector<t_satObs*>& satObs, t_output* output) {
   QMutexLocker locker(&_mutex);
   
@@ -178,5 +178,5 @@
 //
 ////////////////////////////////////////////////////////////////////////////
-void bncPPPclient::putNewObs(t_satData* satData) {
+void t_pppClient::putNewObs(t_satData* satData) {
 
   // Set Observations GPS and Glonass
@@ -234,5 +234,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncPPPclient::putOrbCorrections(const std::vector<t_orbCorr*>& corr) {
+void t_pppClient::putOrbCorrections(const std::vector<t_orbCorr*>& corr) {
   QMutexLocker locker(&_mutex);
 }
@@ -240,5 +240,5 @@
 // 
 ////////////////////////////////////////////////////////////////////////////
-void bncPPPclient::putClkCorrections(const std::vector<t_clkCorr*>& corr) {
+void t_pppClient::putClkCorrections(const std::vector<t_clkCorr*>& corr) {
   QMutexLocker locker(&_mutex);
 }
@@ -263,5 +263,5 @@
 // Satellite Position
 ////////////////////////////////////////////////////////////////////////////
-t_irc bncPPPclient::getSatPos(const bncTime& tt, const QString& prn, 
+t_irc t_pppClient::getSatPos(const bncTime& tt, const QString& prn, 
                               ColumnVector& xc, ColumnVector& vv) {
   if (_eph.contains(prn)) {
@@ -280,5 +280,5 @@
 // Correct Time of Transmission
 ////////////////////////////////////////////////////////////////////////////
-t_irc bncPPPclient::cmpToT(t_satData* satData) {
+t_irc t_pppClient::cmpToT(t_satData* satData) {
 
   double prange = satData->P3;
Index: /trunk/BNC/src/PPP_free/pppClient.h
===================================================================
--- /trunk/BNC/src/PPP_free/pppClient.h	(revision 6084)
+++ /trunk/BNC/src/PPP_free/pppClient.h	(revision 6085)
@@ -41,17 +41,17 @@
 class t_satBias;
 
-class bncPPPclient : public bncEphUser {
+class t_pppClient : public bncEphUser {
  public:
-  bncPPPclient(const t_pppOptions* opt);
-  ~bncPPPclient();
-  void                 processEpoch(const std::vector<t_satObs*>& satObs, t_output* output);
-  void                 putEphemeris(const t_eph* eph);                  
-  void                 putOrbCorrections(const std::vector<t_orbCorr*>& corr); 
-  void                 putClkCorrections(const std::vector<t_clkCorr*>& corr); 
-  void                 putBiases(const std::vector<t_satBias*>& satBias);   
-  QByteArray           staID() const {return _staID;}
-  const t_pppOptions*  opt() const {return _opt;}
-  static bncPPPclient* instance();
-  std::ostringstream&  log() {return *_log;}
+  t_pppClient(const t_pppOptions* opt);
+  ~t_pppClient();
+  void                processEpoch(const std::vector<t_satObs*>& satObs, t_output* output);
+  void                putEphemeris(const t_eph* eph);                  
+  void                putOrbCorrections(const std::vector<t_orbCorr*>& corr); 
+  void                putClkCorrections(const std::vector<t_clkCorr*>& corr); 
+  void                putBiases(const std::vector<t_satBias*>& satBias);   
+  QByteArray          staID() const {return _staID;}
+  const t_pppOptions* opt() const {return _opt;}
+  static t_pppClient* instance();
+  std::ostringstream& log() {return *_log;}
 
  private:
Index: /trunk/BNC/src/src.pri
===================================================================
--- /trunk/BNC/src/src.pri	(revision 6084)
+++ /trunk/BNC/src/src.pri	(revision 6085)
@@ -128,8 +128,6 @@
   INCLUDEPATH += PPP_free
   DEFINES += USE_PPP_FREE
-  HEADERS += PPP_free/pppClient.h   PPP_free/bncpppclient.h   PPP_free/bncmodel.h   \
-             PPP_free/bancroft.h
-  SOURCES += PPP_free/pppClient.cpp PPP_free/bncpppclient.cpp PPP_free/bncmodel.cpp \
-             PPP_free/bancroft.cpp
+  HEADERS += PPP_free/pppClient.h   PPP_free/bncmodel.h   PPP_free/bancroft.h
+  SOURCES += PPP_free/pppClient.cpp PPP_free/bncmodel.cpp PPP_free/bancroft.cpp
 }
 