Index: /trunk/BNC/src/PPP/pppClient.h
===================================================================
--- /trunk/BNC/src/PPP/pppClient.h	(revision 6134)
+++ /trunk/BNC/src/PPP/pppClient.h	(revision 6135)
@@ -8,4 +8,5 @@
 #include "pppOptions.h"
 #include "pppModel.h"
+#include "satObs.h"
 
 class bncAntex;
Index: /trunk/BNC/src/PPP/pppSatObs.h
===================================================================
--- /trunk/BNC/src/PPP/pppSatObs.h	(revision 6134)
+++ /trunk/BNC/src/PPP/pppSatObs.h	(revision 6135)
@@ -1,4 +1,4 @@
-#ifndef SATOBS_H
-#define SATOBS_H
+#ifndef PPPSATOBS_H
+#define PPPSATOBS_H
 
 #include <string>
@@ -6,4 +6,5 @@
 #include <newmat.h>
 #include "pppInclude.h"
+#include "satObs.h"
 #include "bnctime.h"
 
Index: /trunk/BNC/src/pppInclude.h
===================================================================
--- /trunk/BNC/src/pppInclude.h	(revision 6134)
+++ /trunk/BNC/src/pppInclude.h	(revision 6135)
@@ -10,4 +10,5 @@
 #include "ephemeris.h"
 #include "t_prn.h"
+#include "satObs.h"
 
 namespace BNC_PPP {
@@ -34,42 +35,4 @@
   std::string  _log;          
   bool         _error;        
-};
-
-class t_frqObs  {
- public:
-  t_frqObs() {
-    _code            = 0.0;          
-    _codeValid       = false;     
-    _phase           = 0.0;         
-    _phaseValid      = false;    
-    _doppler         = 0.0;       
-    _dopplerValid    = false;  
-    _snr             = 0.0;           
-    _snrValid        = false;      
-    _slip            = false;          
-    _slipCounter     = 0;   
-    _biasJumpCounter = 0;
-  }
-  std::string       _rnxType2ch; 
-  double            _code;          
-  bool              _codeValid;     
-  double            _phase;         
-  bool              _phaseValid;    
-  double            _doppler;       
-  bool              _dopplerValid;  
-  double            _snr;           
-  bool              _snrValid;      
-  bool              _slip;          
-  int               _slipCounter;   
-  int               _biasJumpCounter;
-};
-
-class t_satObs {
- public:
-  t_satObs() {}
-  ~t_satObs() {for (unsigned ii = 0; ii < _obs.size(); ii++) delete _obs[ii];}
-  t_prn                  _prn;
-  bncTime                _time;
-  std::vector<t_frqObs*> _obs;
 };
 
Index: /trunk/BNC/src/satObs.h
===================================================================
--- /trunk/BNC/src/satObs.h	(revision 6135)
+++ /trunk/BNC/src/satObs.h	(revision 6135)
@@ -0,0 +1,99 @@
+#ifndef SATOBS_H
+#define SATOBS_H
+
+#include <string>
+#include <vector>
+#include <newmat.h>
+
+#include "bncconst.h"
+#include "bnctime.h"
+#include "t_prn.h"
+
+class t_frqObs  {
+ public:
+  t_frqObs() {
+    _code            = 0.0;          
+    _codeValid       = false;     
+    _phase           = 0.0;         
+    _phaseValid      = false;    
+    _doppler         = 0.0;       
+    _dopplerValid    = false;  
+    _snr             = 0.0;           
+    _snrValid        = false;      
+    _slip            = false;          
+    _slipCounter     = 0;   
+    _biasJumpCounter = 0;
+  }
+  std::string       _rnxType2ch; 
+  double            _code;          
+  bool              _codeValid;     
+  double            _phase;         
+  bool              _phaseValid;    
+  double            _doppler;       
+  bool              _dopplerValid;  
+  double            _snr;           
+  bool              _snrValid;      
+  bool              _slip;          
+  int               _slipCounter;   
+  int               _biasJumpCounter;
+};
+
+class t_satObs {
+ public:
+  t_satObs() {}
+  ~t_satObs() {for (unsigned ii = 0; ii < _obs.size(); ii++) delete _obs[ii];}
+  t_prn                  _prn;
+  bncTime                _time;
+  std::vector<t_frqObs*> _obs;
+};
+
+class t_orbCorr {
+ public:
+  t_prn          prn() const {return _prn;}
+  unsigned short IOD() const {return _iod;}
+  t_prn          _prn;
+  unsigned short _iod;
+  bncTime        _time;
+  char           _system;
+  double         _xr[3];
+  double         _dotXr[3]; 
+};
+
+class t_clkCorr {
+ public:
+  t_prn          prn() const {return _prn;}
+  unsigned short IOD() const {return _iod;}
+  t_prn          _prn;
+  unsigned short _iod;
+  bncTime        _time;
+  double         _dClk;
+  double         _dotDClk;
+  double         _dotDotDClk;
+  double         _clkPartial;
+};
+
+class t_frqBias {
+ public:
+  t_frqBias() {
+    _code       = 0.0;          
+    _codeValid  = false;     
+    _phase      = 0.0;         
+    _phaseValid = false;    
+  }
+  std::string _rnxType2ch;
+  double      _code;          
+  bool        _codeValid;     
+  double      _phase;         
+  bool        _phaseValid;    
+};
+
+class t_satBias {
+ public:
+  t_prn                  _prn;
+  bncTime                _time;
+  int                    _nx;
+  int                    _jumpCount;
+  std::vector<t_frqBias> _bias;
+};
+
+#endif