Index: trunk/BNC/src/bnchelp.html
===================================================================
--- trunk/BNC/src/bnchelp.html	(revision 6265)
+++ trunk/BNC/src/bnchelp.html	(revision 6326)
@@ -704,5 +704,5 @@
 <p><a name="ephemeris"><h4>3.5. RINEX Ephemeris</h4></p>
 <p>
-Broadcast Ephemeris can be saved as RINEX Navigation files when received via RTCM Version 3 e.g. as message types 1019 (GPS) or 1020 (GLONASS) or 1045 and 1046 (Galileo). The file name convention follows the details given in section 'RINEX File Names' except that the first four characters are 'BRDC' and the last character is
+Broadcast Ephemeris can be saved as RINEX Navigation files when received via RTCM Version 3 e.g. as message types 1019 (GPS) or 1020 (GLONASS) or 1044 (QZSS) or 1045 and 1046 (Galileo). The file name convention follows the details given in section 'RINEX File Names' except that the first four characters are 'BRDC' and the last character is
 </p>
 <ul>
@@ -1534,5 +1534,5 @@
 <ul>
 <li>requires pulling in addition a stream carrying satellite orbit and clock corrections to Broadcast Ephemeris in the form of RTCM Version 3 'State Space Representation' (SSR) messages. Note that for BNC these Broadcast Corrections need to be referred to the satellite's Antenna Phase Center (APC). Streams providing such messages are listed on <u>http://igs.bkg.bund.de/ntrip/orbits</u>. Stream 'CLK11' on NTRIP Broadcaster 'products.igs-ip.net:2101' is an example.</li>
-<li>may require pulling a stream carrying Broadcast Ephemeris available as RTCM Version 3 message types 1019, 1020, 1045 and 1046. This is a must only when the stream coming from the receiver does not contain Broadcast Ephemeris or provides them only at very low repetition rate. Streams providing such messages are listed on <u>http://igs.bkg.bund.de/ntrip/ephemeris</u>. Stream 'RTCM3EPH' on caster 'products.igs-ip.net:2101' is an example.</li>
+<li>may require pulling a stream carrying Broadcast Ephemeris available as RTCM Version 3 message types 1019, 1020, 1044, 1045 and 1046. This is a must only when the stream coming from the receiver does not contain Broadcast Ephemeris or provides them only at very low repetition rate. Streams providing such messages are listed on <u>http://igs.bkg.bund.de/ntrip/ephemeris</u>. Stream 'RTCM3EPH' on caster 'products.igs-ip.net:2101' is an example.</li>
 </ul>
 </p>
@@ -1658,5 +1658,5 @@
 <ul>
 <li>BNC does correct for Solid Earth Tides and Phase Windup.</li>
-<li>Satellite antenna phase center offsets are not corrected because applied orbit/clock corrections are referred to the satellite's antenna phase center.</li>
+<li>Satellite antenna phase center offsets are corrected.</li>
 <li>Satellite antenna phase center variations are neglected because this is a small effect usually less than 2 centimeters.</li>
 <li>Observations can be corrected for a Receiver Antenna Offset. Depending on whether or not this correction is applied, the estimated position is either that of the receiver's antenna phase center or that of the receiver's Antenna Reference Point.</li>
@@ -2589,5 +2589,5 @@
 <p><a name="gettable"><h4>3.18.1.1.4 Get Table</h4></p>
 <p>
-Use the 'Get Table' button to download the source-table from the NTRIP Broadcaster. Pay attention to data fields 'format' and 'format-details'. Keep in mind that BNC can only decode and convert streams that come in RTCM Version 2, RTCM Version 3, or RTNET format. For access to observations, Broadcast Ephemeris and Broadcast Corrections in RTCM format streams must contain a selection of appropriate message types as listed in the Annex, cf. data field 'format-details' for available message types and their repetition rates in brackets. Note that in order to produce RINEX Navigation files RTCM Version 3 streams containing message types 1019 (GPS) and 1020 (GLONASS) and 1045, 1046 (Galileo) are required. Select your streams line by line, use +Shift and +Ctrl when necessary. The figure below provides an example source-table.
+Use the 'Get Table' button to download the source-table from the NTRIP Broadcaster. Pay attention to data fields 'format' and 'format-details'. Keep in mind that BNC can only decode and convert streams that come in RTCM Version 2, RTCM Version 3, or RTNET format. For access to observations, Broadcast Ephemeris and Broadcast Corrections in RTCM format streams must contain a selection of appropriate message types as listed in the Annex, cf. data field 'format-details' for available message types and their repetition rates in brackets. Note that in order to produce RINEX Navigation files RTCM Version 3 streams containing message types 1019 (GPS) and 1020 (GLONASS) and 1044 (QZSS) and 1045, 1046 (Galileo) are required. Select your streams line by line, use +Shift and +Ctrl when necessary. The figure below provides an example source-table.
 </p>
 <p>
@@ -2970,6 +2970,19 @@
 
 <tr>
-<td>Sep 2014 &nbsp;</td><td>Version 2.12 &nbsp;</td>
-<td>[Add] Started work on new version in Sep 2014<br>[Mod] RINEX file concatenation<br>[Add] Observation code selection in RINEX file editing</td>
+<td>Sep 2014 &nbsp;</td><td>Version 2.12 &nbsp;</td><td>
+[Add] Started work on new version in Sep 2014<br>
+[Mod] RINEX file concatenation<br>[Add] Observation code selection in RINEX file editing<br>
+[Mod] Routine handling of data input and output in RINEX format re-written<br>
+[Mod] QC routines re-written with the goal of handling all signal types<br>
+[Add] Machine-readable output of RINEX QC<br>
+[Add] PPP processing of any number of linear combinations of GNSS measurements selected by user<br>
+[Add] Second PPP client for parallel processing of an arbitrary number of stations in separate threads<br>
+[Add] Decoding RTCM SSR phase bias messages<br>
+[Add] Decoding RTCM SSR ionospheric model messages, single-layer model for total electron content<br>
+[Add] RTCMv3 QZSS Broadcast Ephemeris message 1044<br>
+[Add] Handle old-fashioned SNR values in RINEX<br>
+[Mod] SNR and MP visualization depending on RINEX observation attribute<br>
+[Bug] Saastamoinen tropospheric correction for very high elevation receivers
+</td>
 </tr>
 
@@ -3103,4 +3116,6 @@
 <li>Type 1019, GPS ephemeris.</li>
 <li>Type 1020, GLONASS ephemeris.</li>
+<li>Type 1043, SBAS ephemeris.</li>
+<li>Type 1044, QZSS ephemeris.</li>
 <li>Type 1045, Galileo F/NAV ephemeris.</li>
 <li>Type 1046, Galileo I/NAV ephemeris.</li>