Index: /trunk/BNC/src/bncwindow.cpp
===================================================================
--- /trunk/BNC/src/bncwindow.cpp	(revision 6332)
+++ /trunk/BNC/src/bncwindow.cpp	(revision 6333)
@@ -1750,4 +1750,11 @@
     enableStartStop();
   }
+  else if (!_sp3CompFileChooser->fileName().isEmpty()) {
+    _runningSp3Comp = true;
+    t_reqcEdit* reqcEdit = new t_reqcEdit(this);
+    connect(reqcEdit, SIGNAL(finished()), this, SLOT(slotPostProcessingFinished()));
+    reqcEdit->start();
+    enableStartStop();
+  }
   else {
     startRealTime();
@@ -2420,7 +2427,8 @@
 void bncWindow::slotPostProcessingFinished() {
   delete _caster; _caster = 0; BNC_CORE->setCaster(0);
-  _runningPPP  = false;
-  _runningEdit = false;
-  _runningQC   = false;
+  _runningPPP     = false;
+  _runningEdit    = false;
+  _runningQC      = false;
+  _runningSp3Comp = false;
   _actStart->setText(tr("Sta&rt"));
   enableStartStop();
Index: /trunk/BNC/src/orbComp/sp3Comp.cpp
===================================================================
--- /trunk/BNC/src/orbComp/sp3Comp.cpp	(revision 6333)
+++ /trunk/BNC/src/orbComp/sp3Comp.cpp	(revision 6333)
@@ -0,0 +1,85 @@
+// Part of BNC, a utility for retrieving decoding and
+// converting GNSS data streams from NTRIP broadcasters.
+//
+// Copyright (C) 2007
+// German Federal Agency for Cartography and Geodesy (BKG)
+// http://www.bkg.bund.de
+// Czech Technical University Prague, Department of Geodesy
+// http://www.fsv.cvut.cz
+//
+// Email: euref-ip@bkg.bund.de
+//
+// This program is free software; you can redistribute it and/or
+// modify it under the terms of the GNU General Public License
+// as published by the Free Software Foundation, version 2.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+/* -------------------------------------------------------------------------
+ * BKG NTRIP Client
+ * -------------------------------------------------------------------------
+ *
+ * Class:      t_sp3Comp
+ *
+ * Purpose:    Compare SP3 Files
+ *
+ * Author:     L. Mervart
+ *
+ * Created:    24-Nov-2014
+ *
+ * Changes:    
+ *
+ * -----------------------------------------------------------------------*/
+
+#include <iostream>
+#include "sp3Comp.h"
+#include "bnccore.h"
+#include "bncsettings.h"
+#include "bncutils.h"
+
+using namespace std;
+
+// Constructor
+////////////////////////////////////////////////////////////////////////////
+t_sp3Comp::t_sp3Comp(QObject* parent) : QThread(parent) {
+
+//  bncSettings settings;
+//
+//  _logFileName    = settings.value("reqcOutLogFile").toString(); expandEnvVar(_logFileName);
+}
+
+// Destructor
+////////////////////////////////////////////////////////////////////////////
+t_sp3Comp::~t_sp3Comp() {
+}
+
+//  
+////////////////////////////////////////////////////////////////////////////
+void t_sp3Comp::run() {
+ 
+  // Open Log File
+  // -------------
+//  _logFile = new QFile(_logFileName);
+//  if (_logFile->open(QIODevice::WriteOnly | QIODevice::Text)) {
+//    _log = new QTextStream();
+//    _log->setDevice(_logFile);
+//  }
+
+  // Exit (thread)
+  // -------------
+  if (BNC_CORE->mode() != t_bncCore::interactive) {
+    qApp->exit(0);
+  }
+  else {
+    emit finished();
+    deleteLater();
+  }
+}
+
Index: /trunk/BNC/src/orbComp/sp3Comp.h
===================================================================
--- /trunk/BNC/src/orbComp/sp3Comp.h	(revision 6333)
+++ /trunk/BNC/src/orbComp/sp3Comp.h	(revision 6333)
@@ -0,0 +1,53 @@
+// Part of BNC, a utility for retrieving decoding and
+// converting GNSS data streams from NTRIP broadcasters.
+//
+// Copyright (C) 2007
+// German Federal Agency for Cartography and Geodesy (BKG)
+// http://www.bkg.bund.de
+// Czech Technical University Prague, Department of Geodesy
+// http://www.fsv.cvut.cz
+//
+// Email: euref-ip@bkg.bund.de
+//
+// This program is free software; you can redistribute it and/or
+// modify it under the terms of the GNU General Public License
+// as published by the Free Software Foundation, version 2.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this program; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+#ifndef SP3COMP_H
+#define SP3COMP_H
+
+#include <QtCore>
+#include "rnxobsfile.h"
+#include "rnxnavfile.h"
+#include "ephemeris.h"
+
+class t_sp3Comp : public QThread {
+Q_OBJECT
+ 
+ public:
+  t_sp3Comp(QObject* parent);
+
+ protected:
+  ~t_sp3Comp();
+
+ signals:
+  void finished();
+   
+ public slots:
+
+ public:
+  virtual void run();
+ 
+ private:
+};
+
+#endif
Index: /trunk/BNC/src/src.pri
===================================================================
--- /trunk/BNC/src/src.pri	(revision 6332)
+++ /trunk/BNC/src/src.pri	(revision 6333)
@@ -65,5 +65,5 @@
           rinex/graphwin.h         rinex/polarplot.h                  \
           rinex/availplot.h        rinex/eleplot.h                    \
-          rinex/dopplot.h
+          rinex/dopplot.h          orbComp/sp3Comp.h
 
 HEADERS       += serial/qextserialbase.h serial/qextserialport.h
@@ -100,5 +100,5 @@
           rinex/graphwin.cpp       rinex/polarplot.cpp                \
           rinex/availplot.cpp      rinex/eleplot.cpp                  \
-          rinex/dopplot.cpp
+          rinex/dopplot.cpp        orbComp/sp3Comp.cpp
 
 SOURCES       += serial/qextserialbase.cpp serial/qextserialport.cpp